(function($) {

	//################################################################################################
	// Функция для переключения экшенов статьи
	//################################################################################################
	
	$.fn.rianActions = function(options) {
		
		// Обявляем дефолтные значения и переопределяем их , если они переданы в функцию
        var options = $.extend({
			target: 'LI',
			innerTarget: 'A',
			innerTargetLink: 'href',
			innerTargetID: 'class',
			//coneElement: 'ins',
			activeClass: 'active',
			pagesClass: '.apage'
        }, options || {});	

 
		$(this).click(function(e){

			// Проверяем по какому объекту кликнули, если НЕ объект из options.target, то прерываем выполнение функции
			while (e.target != this) {
				if (e.target.tagName == options.target) {
					break;
				}
				e.target = e.target.parentNode;
			}
			if(e.target.tagName != options.target){return;}
		
			// Отменяет дефолтное действие у события
			e.preventDefault();
		
			// Делаем объект
			var link = $(e.target);
			
			// Ищем внутри нашего объекта тэг a с аттрибутом href
			var linkTo = link.find(options.innerTarget).attr(options.innerTargetLink);
			
			if (linkTo) {
				// если аттрибут href существует, то переходим по ссылке, содердащейся в нем.
				window.location.href = linkTo;
			} 
			else {
				// В противном случае ищем аттрибут class, берем его значение.
				var id = link.find(options.innerTarget).attr(options.innerTargetID);
					
				// Показываем/скрываем блок с таким id
				$('#'+id).toggle();
				// Закрываем остальные родственные блоки
				$('#'+id).siblings(options.pagesClass).hide();
				
				// Переключаем класс (options.activeClass) у элемента по которому кликаем 
				link.toggleClass(options.activeClass);
				// Выключаем класс у родственных элементов
				link.siblings().removeClass(options.activeClass);

				// Ищем и показываем/скрываем элемент options.coneElement
				//link.find(options.coneElement).toggle();
				// Ищем и скрываем элемент options.coneElement у всех родственных link элементов			
				//link.siblings().find(options.coneElement).hide();
			}
		});
	}



	//################################################################################################
	// Функция для переключения размеров шрифта
	//################################################################################################
	
	$.fn.rianFontScale = function(options) {
		
		// Обявляем дефолтные значения и переопределяем их , если они переданы в функцию
        var options = $.extend({
			size1: '12px',
			size2: '14px',
			size3: '18px',
			button1: 'size1',
			button2: 'size2',
			button3: 'size3',
			activeClass: 'active'
        }, options || {});		
			
        var text = $(this);
        
        // Функции
        
        // Функция убирающая класс activeClass с кнопок переключения размера
        var removeActiveClass = function(){
        	$("#"+options.button1).removeClass(options.acticeClass);
        	$("#"+options.button2).removeClass(options.acticeClass);
        	$("#"+options.button3).removeClass(options.acticeClass);
        }

        // События        
        
        // Устанавливаем мелкий размер шрифта по клику на перевую кнопку
        $("#"+options.button1).click(function(){
        	text.css('font-size', options.size1);
        	removeActiveClass();
        	$(this).addClass(options.activeClass);
        });

        // Устанавливаем средний размер шрифта по клику на вторую кнопку        
        $("#"+options.button2).click(function(){
        	text.css('font-size', options.size2);
        	removeActiveClass();
        	$(this).addClass(options.activeClass);
        });

        // Устанавливаем крупный размер шрифта по клику на третью кнопку
        $("#"+options.button3).click(function(){
        	text.css('font-size', options.size3);
        	removeActiveClass();
        	$(this).addClass(options.activeClass);
        });        
	}



	//################################################################################################
	// Функция для подсветки input, textarea и select полей формы
	//################################################################################################
	$.fn.rianFormHighlight = function(options) {
		
	// Обявляем дефолтные значения и переопределяем их , если они переданы в функцию
        var options = $.extend({
			colorOn: "#f5f5f5",
			colorOut: "#ffffff"
        }, options || {});	
				
		//Подсветка

        //$(options.element+':eq(0)', box)
        
        $("input[type=text], input[type=password] , textarea, select", this).focus(function(){  // Вешаем на событие onFocus
        	$(this).css({'background-color': options.colorOn});
		});
		
		$("input[type=text], input[type=password] , textarea, select", this).blur(function(){  // Вешаем на событие onBlur
			$(this).css({'background-color': options.colorOut});
		});
	}
	

	//################################################################################################
	// Функция для создания слайдшоу
	//################################################################################################
	$.fn.rianSlideShow = function(options) {
		
		
		// Обявляем дефолтные настройки
        var options = $.extend({
			element: 'IMG',
			autostart: 'true',
			delay: '5000',
			buttons: 'buttons',
			next: 'next',
			prev: 'prev',
			play: 'play',
			stop: 'stop',
			position: 'position',
			positionCurrent: 'current',
			positionTotal: 'total',
			copyright: 'copyright',
			copyrightAttr: 'title',
			copyrightElement: 'div'
        }, options || {});	

		
		// Объявляем переменные и присваиваем им значения
		var box = $(this);
		var elements = box.find(options.element);
		var lenght = elements.length;
		var lastImage = lenght - 1;
		var copyright = $('#'+options.copyright);
		var copyrightElements = $('#'+options.copyright+' '+options.copyrightElement);		
		

		// Включаем первый кадр
		$(options.element+':eq(0)', box).removeClass("visible");
		$(options.element+':eq(0)', box).show();
		$("#"+options.buttons).show();
		$("#"+options.position).show();

		// Функции


		// Функция обновляющая номер текущго кадра
		function updateCurrentNum(num){
			$('#'+options.positionCurrent).empty().append(num);
		}



		// Функция переключения картинки
		function switchImage(direction){
			
			if(!direction){direction == 'next';}
			
			elements.queue("fx", []);
			elements.stop(true, true);
			
			//$('#'+options.stop).click();
			
			var currentImage = $(options.element+':visible', box);
			var currentImageNum = $(options.element, box).index($(options.element+':visible', box));

			var nextImage;
			var nextImageNum;


			// Next
			if(direction == 'next'){
				if (currentImageNum == lastImage) {nextImageNum = 0;}
				else {nextImageNum = currentImageNum + 1;}
				if(typeof(rianSlideShowNext) == 'function'){rianSlideShowNext(currentImageNum,nextImageNum);}
			}


			// Previous
			if(direction == 'prev'){				
				if (currentImageNum == 0) {nextImageNum = lastImage;}
				else {nextImageNum = currentImageNum - 1;}
				if(typeof(rianSlideShowPrev) == 'function'){rianSlideShowPrev(currentImageNum,nextImageNum);}
			}
			
			nextImage = $(options.element+':eq('+nextImageNum+')', box);
			nextImageCopyright = $(options.copyrightElement+':eq('+nextImageNum+')', copyright);


			currentImage.css('opacity','1');
			elements.fadeOut('slow');
			copyrightElements.hide();


			updateCurrentNum(nextImageNum+1);


			nextImage.fadeIn('slow');
			nextImageCopyright.show();			
		}


		// Слайдшоу
		function slideShow(){			
			box.animate({borderTopWidth: '0'}, parseFloat(options.delay), function () {
				switchImage('next');
				slideShow();
			});			
			
		}


		// События


		// Показать навигацию при наведении мыши
		$(this).mouseover(function(){
			$('#'+options.buttons).show();
			$('#'+options.position).show();
		});


		// Скрыть навигацию когда мыш ушла с объекта
		$(this).mouseout(function(){
			$('#'+options.buttons).hide();
			$('#'+options.position).hide();
		});


		// Кнопка вперед
		$('#'+options.next).click(function(){
			$('#'+options.stop).click();
			switchImage('next');
		});


		// Кнопка назад
		$('#'+options.prev).click(function(){
			$('#'+options.stop).click();
			switchImage('prev');
		});


		// Кнопка запуска слайдшоу
		$('#'+options.play).click(function(){			
			slideShow();
			$(this).css('display', 'none');
			$('#'+options.stop).css('display', 'block');
		});


		// Кнопка остановки слайдшоу
		$('#'+options.stop).click(function(){
			box.queue("fx", []);
			box.stop(true, false);
			$(this).css('display', 'none');
			$('#'+options.play).css('display', 'block');
		});	
		
		
		// Автостарт
		if(options.autostart == 'true'){
			slideShow();
			$('#'+options.play).css('display', 'none');
			$('#'+options.stop).css('display', 'block');
		}		
	}


	//################################################################################################
	// Функция для создания табов
	//################################################################################################	
	$.fn.rianTabs = function(options) {
		
		// Обявляем дефолтные значения и переопределяем их , если они переданы в функцию
        var options = $.extend({
			target: 'A',
			targetAttr: 'class',
			activeClass: 'active',
            pagesClass: 'div.tabspage'
        }, options || {});		
			
		$(this).click(function(e){  // Вешаем на клик
			
			// Проверяем по какому объекту кликнули, если НЕ объект из options.targetAttr то прерываем выполнение функции
			if(e.target.tagName != options.target){return;}
			
			// Отменяет дефолтное действие у события
			e.preventDefault();
			
			// Делаем объект
			var link = $(e.target);
			
			//Берем значение из аттрибута, указанного в options.targetAttr
			var id = link.attr(options.targetAttr);
	
			// Показываем блок с таким же id как у ссылки в href, закрываем остальные видимые блоки (селектор options.pagesClass)
			$("#filtered li").hide();
			$("#filtered li."+id).show();
			
			//$('#'+id).show();
			//$('#'+id).siblings(options.pagesClass).hide();
	  		
			// Убираем класс options.activeClass у всех элементов родственных элементов на уровень выше от options.target
			link.siblings().removeClass(options.activeClass);
			
			// Добавляем элементу на уровень выше от options.target класс options.activeClass
			link.addClass(options.activeClass);
			
		});
	}	

	//################################################################################################
	// 
	//################################################################################################	
	$.fn.videoInject = function(options) {
		var options = $.extend({
			pos: 1,
			smallPref: 'video_small_',
			smallBtnPref: 'video_small_button_',
			fullPref: 'video_full_',
			fullBtnPref: 'video_full_button_',
			toBlogPref: 'video_to_blog_',
			toBlogBtnPref: 'video_to_blog_show_',
			toBlogFullBtnPref: 'video_full_to_blog_show_',
			toBlogClosePref: 'video_to_blog_hide_',
			fullToBlogClass: 'video_to_blog_full'
		}, options || {});

		var obj = $(this);
		var pos = options.pos;
		var small = obj.find('#' + options.smallPref + pos);
		var smallBtn = obj.find('#' + options.smallBtnPref + pos);
		var full = obj.find('#' + options.fullPref + pos);
		var fullBtn = obj.find('#' + options.fullBtnPref + pos);
		var toBlog = obj.find('#' + options.toBlogPref + pos);
		var toBlogBtn = obj.find('#' + options.toBlogBtnPref + pos);
		var toBlogFullBtn = obj.find('#' + options.toBlogFullBtnPref + pos);
		var toBlogClose = obj.find('#' + options.toBlogClosePref + pos);
		
		smallBtn.click(function(){
			toBlog.hide();
			small.hide();
			full.show();
		});

		fullBtn.click(function(){
			toBlog.hide();
			full.hide();
			small.show();
		});
		
		toBlogBtn.click(function(){
			toBlog.removeClass(options.fullToBlogClass).show();
		});
		
		toBlogFullBtn.click(function(){
			toBlog.addClass(options.fullToBlogClass).show();
		});
		
		toBlogClose.click(function(){
			toBlog.hide();
		});
	}
	
	$.fn.mediaInject = function(options) {
		var options = $.extend({
			pos: 1,
			smallPref: 'small_media_',
			smallBtnPref: 'image_small_button_',
			fullPref: 'full_media_',
			fullBtnPref: 'image_full_button_'
		}, options || {});

		var obj = $(this);
		var pos = options.pos;
		var small = obj.find('#' + options.smallPref + pos);
		var smallBtn = obj.find('#' + options.smallBtnPref + pos);
		var full = obj.find('#' + options.fullPref + pos);
		var fullBtn = obj.find('#' + options.fullBtnPref + pos);
		
		smallBtn.click(function(){
			if (full.find("img").hasClass("empty")) {
				full.find("img").attr("src", smallBtn.attr("href")).removeClass("empty");
			}
			small.hide();
			full.show();
			
			return false;
		});
		fullBtn.click(function(){
			full.hide();
			small.show();
		});
	}
	
})(jQuery);
